
package com.bd.framework.accessapi;

import java.util.List;

import com.bd.framework.util.Command;

/**
 * <p>
 * Access command for finding entities similar to another entity. 
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 *
 */
public interface FindByExampleAccess<T> extends Command {

    void setExample(T example);
    
    void setOrderBy(String orderBy);
    
    void setOrderByAsc(boolean orderByAsc);
    
    void setExcludeProperties(String[] excludeProperties);

    /**
     * The result of the command.
     */
    List<T> getResult();


} 