
package com.bd.framework.accessapi;

import java.util.List;
import java.util.Map;

import com.bd.framework.util.Command;

/**
 * <p>
 * Access command for finding objects by query.. 
 * </p>
 * <p>
 * Command design pattern.
 * </p>
 *
 */
public interface FindByQueryAccess<T> extends Command {

    void setQuery(String aQuery);
    
    void setParameters(Map map);

    /**
     * The result of the command.
     */
    List<T> getResult();


} 