package compiledtemplates;

import java.util.*;
import util.EcoreGenerationHelper;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.codegen.util.*;

public class ConcreteFactory
{
  protected static String nl;
  public static synchronized ConcreteFactory create(String lineSeparator)
  {
    nl = lineSeparator;
    ConcreteFactory result = new ConcreteFactory();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = NL + "package ";
  protected final String TEXT_3 = ";" + NL;
  protected final String TEXT_4 = NL + NL + "/**" + NL + " * <p>" + NL + " * Concrete Factory that creates ";
  protected final String TEXT_5 = " ";
  protected final String TEXT_6 = " objects. " + NL + " * </p>" + NL + " * <p>" + NL + " * Abstract factory design pattern." + NL + " * </p>" + NL + " * <!-- begin-user-doc -->" + NL + " * <!-- end-user-doc -->" + NL + " *" + NL + " * @generated" + NL + " */" + NL + "public class ";
  protected final String TEXT_7 = "FactoryImpl extends ";
  protected final String TEXT_8 = "Factory {" + NL;
  protected final String TEXT_9 = NL + "    /**" + NL + "     * <!-- begin-user-doc -->" + NL + "     * <!-- end-user-doc -->" + NL + "     * @generated" + NL + "     */" + NL + "    public ";
  protected final String TEXT_10 = " create";
  protected final String TEXT_11 = "() {";
  protected final String TEXT_12 = NL + "        return new ";
  protected final String TEXT_13 = "Impl";
  protected final String TEXT_14 = "(getPersistentClass());";
  protected final String TEXT_15 = NL + "        return new ";
  protected final String TEXT_16 = "Impl";
  protected final String TEXT_17 = "(getPersistentClass());";
  protected final String TEXT_18 = NL + "        return new ";
  protected final String TEXT_19 = "Impl";
  protected final String TEXT_20 = "();";
  protected final String TEXT_21 = NL + "        return new ";
  protected final String TEXT_22 = "Impl";
  protected final String TEXT_23 = "();";
  protected final String TEXT_24 = NL + "        return new ";
  protected final String TEXT_25 = "Impl";
  protected final String TEXT_26 = "();";
  protected final String TEXT_27 = NL + "    }" + NL + "     ";
  protected final String TEXT_28 = NL + NL + NL + "} ";

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    

    EClass eClass = (EClass) argument;
EPackage ePackage = eClass.getEPackage();

if (!eClass.getName().endsWith("Repository")) {
    throw new IllegalArgumentException("Expect name of class argument to end with \"Repository\""); 
}
String baseName = eClass.getName().substring(0, eClass.getName().length() - "Repository".length());
String productType = "Access";

EcoreGenerationHelper h = new EcoreGenerationHelper();
String apiPackageName = h.getQualifiedName(ePackage.getESuperPackage()) + ".accessapi";
String implPackageName = h.getQualifiedName(ePackage.getESuperPackage()) + ".accessimpl";
String fwApiPackageName = h.getQualifiedName(ePackage.getESuperPackage().getESuperPackage()) + ".framework.accessapi";
String fwImplPackageName = h.getQualifiedName(ePackage.getESuperPackage().getESuperPackage()) + ".framework.accessimpl";
h.makeImportManager(implPackageName);

    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(implPackageName);
    stringBuffer.append(TEXT_3);
    
StringBuffer importStringBuffer = stringBuffer;
int importInsertionPoint = stringBuffer.length();
h.getImportManager().addCompilationUnitImports(stringBuffer.toString());
h.addImport(apiPackageName + "." + baseName + productType + "Factory");
h.addImport(apiPackageName + ".*");
h.addImport(fwApiPackageName + ".*");
h.addImport(fwImplPackageName + ".*");

    stringBuffer.append(TEXT_4);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_6);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_7);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_8);
    for (EOperation op : h.getOperations(eClass)) {
  if (h.getAnnotation(op, "noaccessobject") != null) continue;
  String mappedOpName = h.getMappedOperationName(op);

    stringBuffer.append(TEXT_9);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_10);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_11);
    if (mappedOpName.equals("findById")) {
    stringBuffer.append(TEXT_12);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_13);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_14);
    } else if (mappedOpName.equals("findAll") ||
                     mappedOpName.equals("findByExample")) {
    stringBuffer.append(TEXT_15);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_16);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_17);
    } else if (mappedOpName.equals("findByQuery")) {
    stringBuffer.append(TEXT_18);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_19);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_20);
    } else if (mappedOpName.equals("create") ||
                     mappedOpName.equals("update") ||
                     mappedOpName.equals("delete")) {
    stringBuffer.append(TEXT_21);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_22);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_23);
    } else {
    stringBuffer.append(TEXT_24);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_25);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_26);
    }
    stringBuffer.append(TEXT_27);
    }
    stringBuffer.append(TEXT_28);
    importStringBuffer.insert(importInsertionPoint, h.getImportManager().computeSortedImports());
    return stringBuffer.toString();
  }
}
