package compiledtemplates;

import java.util.*;
import util.DatabaseGenerationHelper;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.codegen.util.*;

public class Hibernate
{
  protected static String nl;
  public static synchronized Hibernate create(String lineSeparator)
  {
    nl = lineSeparator;
    Hibernate result = new Hibernate();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "<?xml version=\"1.0\"?>" + NL + "<!DOCTYPE hibernate-mapping PUBLIC" + NL + "\t\"-//Hibernate/Hibernate Mapping DTD//EN\"" + NL + "\t\"http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd\" >" + NL + "" + NL + "<hibernate-mapping package=\"";
  protected final String TEXT_2 = "\" >";
  protected final String TEXT_3 = NL + "  <class name=\"";
  protected final String TEXT_4 = "\" " + NL + "         table=\"";
  protected final String TEXT_5 = "\">" + NL + "    <id name=\"";
  protected final String TEXT_6 = "\" >" + NL + "      <generator class=\"native\" />" + NL + "    </id>";
  protected final String TEXT_7 = NL + "    <discriminator column=\"";
  protected final String TEXT_8 = "_TYPE\" type=\"string\" />";
  protected final String TEXT_9 = NL + "    <property name=\"UUIDString\" />";
  protected final String TEXT_10 = NL + "    <property name=\"";
  protected final String TEXT_11 = "\" />";
  protected final String TEXT_12 = NL + "  " + NL + "    <many-to-one name=\"";
  protected final String TEXT_13 = "\" column=\"";
  protected final String TEXT_14 = "\" " + NL + "      class=\"";
  protected final String TEXT_15 = "\" />";
  protected final String TEXT_16 = NL + "  " + NL + "    <";
  protected final String TEXT_17 = " name=\"";
  protected final String TEXT_18 = "\" " + NL + "      lazy=\"";
  protected final String TEXT_19 = "\" " + NL + "      inverse=\"true\"";
  protected final String TEXT_20 = NL + "      order-by=\"";
  protected final String TEXT_21 = "\"";
  protected final String TEXT_22 = NL + "      cascade=\"";
  protected final String TEXT_23 = "\">" + NL + "        <!-- use cascade=\"cascade-delete-orphan\" to delete children when parent is deleted -->" + NL + "        <key column=\"";
  protected final String TEXT_24 = "\" />";
  protected final String TEXT_25 = NL + "        <index column=\"";
  protected final String TEXT_26 = "_INDEX\" />";
  protected final String TEXT_27 = NL + "        <one-to-many class=\"";
  protected final String TEXT_28 = "\" />" + NL + "    </";
  protected final String TEXT_29 = ">";
  protected final String TEXT_30 = NL + "  " + NL + "    <set name=\"";
  protected final String TEXT_31 = "\"";
  protected final String TEXT_32 = NL + "      inverse=\"true\"";
  protected final String TEXT_33 = " " + NL + "      table=\"";
  protected final String TEXT_34 = "\"" + NL + "      lazy=\"";
  protected final String TEXT_35 = "\" " + NL + "      cascade=\"";
  protected final String TEXT_36 = "\">" + NL + "        <key column=\"";
  protected final String TEXT_37 = "\" />" + NL + "        <many-to-many" + NL + "          column=\"";
  protected final String TEXT_38 = "\" " + NL + "          class=\"";
  protected final String TEXT_39 = "\" />" + NL + "    </set>";
  protected final String TEXT_40 = NL + "  " + NL + "    <joined-subclass name=\"";
  protected final String TEXT_41 = "\" " + NL + "         table=\"";
  protected final String TEXT_42 = "\">" + NL + "       <key column=\"";
  protected final String TEXT_43 = "\" />";
  protected final String TEXT_44 = NL + "       <property name=\"";
  protected final String TEXT_45 = "\" />";
  protected final String TEXT_46 = NL + "    </joined-subclass>";
  protected final String TEXT_47 = NL + "  </class>" + NL + "  ";
  protected final String TEXT_48 = NL + NL + "</hibernate-mapping>";
  protected final String TEXT_49 = NL;

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    

    EPackage ePackage = (EPackage) argument;

DatabaseGenerationHelper h = new DatabaseGenerationHelper();

    stringBuffer.append(TEXT_1);
    stringBuffer.append(h.getQualifiedName(ePackage));
    stringBuffer.append(TEXT_2);
    for (EClass eClass : h.getClasses(ePackage)) {
  EAttribute idAttribute = h.getIdAttribute(eClass);
  // skip repository classes
  if (eClass.getName().endsWith("Repository")) {continue;}
  // skip subclasses, they are handled as joined-subclass
  if (!h.getExtends(eClass).isEmpty()) {continue;}

    stringBuffer.append(TEXT_3);
    stringBuffer.append(h.getQualifiedName(eClass));
    stringBuffer.append(TEXT_4);
    stringBuffer.append(h.getDatabaseName(eClass));
    stringBuffer.append(TEXT_5);
    stringBuffer.append(h.getName(idAttribute));
    stringBuffer.append(TEXT_6);
    if (!h.getSubClasses(eClass).isEmpty()) {
    stringBuffer.append(TEXT_7);
    stringBuffer.append(h.getDatabaseName(eClass));
    stringBuffer.append(TEXT_8);
    }
    if (h.getNaturalKeys(eClass).isEmpty()) {
    stringBuffer.append(TEXT_9);
    }
    for (EAttribute attribute : h.getAttributes(eClass)) {
    if (attribute == idAttribute) {continue;} 
    stringBuffer.append(TEXT_10);
    stringBuffer.append(h.getName(attribute));
    stringBuffer.append(TEXT_11);
    }
    for (EReference ref : h.getAllOneReferences(eClass)) {
    stringBuffer.append(TEXT_12);
    stringBuffer.append(h.getName(ref));
    stringBuffer.append(TEXT_13);
    stringBuffer.append(h.getForeignKeyName(ref));
    stringBuffer.append(TEXT_14);
    stringBuffer.append(h.getQualifiedName(ref.getEReferenceType()));
    stringBuffer.append(TEXT_15);
    }
    for (EReference ref : h.getManyToOneReferences(eClass)) {
    stringBuffer.append(TEXT_16);
    stringBuffer.append(h.getCollectionType(ref));
    stringBuffer.append(TEXT_17);
    stringBuffer.append(h.getName(ref));
    stringBuffer.append(TEXT_18);
    stringBuffer.append(h.getAnnotation(ref, "lazy", "false"));
    stringBuffer.append(TEXT_19);
    if ("bag".equals(h.getCollectionType(ref))) {
    stringBuffer.append(TEXT_20);
    stringBuffer.append(h.getAnnotation(ref, "orderBy", "ID"));
    stringBuffer.append(TEXT_21);
    }
    stringBuffer.append(TEXT_22);
    stringBuffer.append(h.getAnnotation(ref, "cascade", "all"));
    stringBuffer.append(TEXT_23);
    stringBuffer.append(h.getForeignKeyName(eClass));
    stringBuffer.append(TEXT_24);
    if ("list".equals(h.getCollectionType(ref))) {
    stringBuffer.append(TEXT_25);
    stringBuffer.append(h.getDatabaseName(ref));
    stringBuffer.append(TEXT_26);
    }
    stringBuffer.append(TEXT_27);
    stringBuffer.append(h.getQualifiedName(ref.getEReferenceType()));
    stringBuffer.append(TEXT_28);
    stringBuffer.append(h.getCollectionType(ref).toLowerCase());
    stringBuffer.append(TEXT_29);
    }
    for (EReference ref : h.getManyToManyReferences(eClass)) {
    stringBuffer.append(TEXT_30);
    stringBuffer.append(h.getName(ref));
    stringBuffer.append(TEXT_31);
    if (h.isInverse(ref)) {
    stringBuffer.append(TEXT_32);
    }
    stringBuffer.append(TEXT_33);
    stringBuffer.append(h.getManyToManyJoinTableName(ref));
    stringBuffer.append(TEXT_34);
    stringBuffer.append(h.getAnnotation(ref, "lazy", "false"));
    stringBuffer.append(TEXT_35);
    stringBuffer.append(h.getAnnotation(ref, "cascade", "all"));
    stringBuffer.append(TEXT_36);
    stringBuffer.append(h.getForeignKeyName(eClass));
    stringBuffer.append(TEXT_37);
    stringBuffer.append(h.getForeignKeyName(ref.getEReferenceType()));
    stringBuffer.append(TEXT_38);
    stringBuffer.append(h.getQualifiedName(ref.getEReferenceType()));
    stringBuffer.append(TEXT_39);
    }
    for (EClass subClass : h.getSubClasses(eClass)) {
    stringBuffer.append(TEXT_40);
    stringBuffer.append(h.getQualifiedName(subClass));
    stringBuffer.append(TEXT_41);
    stringBuffer.append(h.getDatabaseName(subClass));
    stringBuffer.append(TEXT_42);
    stringBuffer.append(h.getForeignKeyName(eClass));
    stringBuffer.append(TEXT_43);
    for (EAttribute attribute : h.getAttributes(subClass)) {
    stringBuffer.append(TEXT_44);
    stringBuffer.append(h.getName(attribute));
    stringBuffer.append(TEXT_45);
    }
    // TODO associations also, maybe extract above into jetinc 
    stringBuffer.append(TEXT_46);
    }
    stringBuffer.append(TEXT_47);
    }
    stringBuffer.append(TEXT_48);
    stringBuffer.append(TEXT_49);
    return stringBuffer.toString();
  }
}
