package compiledtemplates;

import java.util.*;
import util.EcoreGenerationHelper;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.codegen.util.*;

public class Repository
{
  protected static String nl;
  public static synchronized Repository create(String lineSeparator)
  {
    nl = lineSeparator;
    Repository result = new Repository();
    nl = null;
    return result;
  }

  protected final String NL = nl == null ? (System.getProperties().getProperty("line.separator")) : nl;
  protected final String TEXT_1 = "";
  protected final String TEXT_2 = NL + "package ";
  protected final String TEXT_3 = ";" + NL;
  protected final String TEXT_4 = NL + NL + "/**" + NL + " * <!-- begin-user-doc -->" + NL + " * Repository for ";
  protected final String TEXT_5 = NL + " * <!-- end-user-doc -->" + NL + " *" + NL + " * @generated" + NL + " */" + NL + "public class ";
  protected final String TEXT_6 = " {" + NL + "" + NL + "    /**" + NL + "     * Reference to the access object factory. " + NL + "     * @generated " + NL + "     */" + NL + "    private ";
  protected final String TEXT_7 = "Factory ";
  protected final String TEXT_8 = "Factory = ";
  protected final String TEXT_9 = "Factory.getInstance();" + NL + "" + NL + "    /** @generated */" + NL + "    public ";
  protected final String TEXT_10 = "() {" + NL + "    }" + NL + "    " + NL;
  protected final String TEXT_11 = NL + "    /**" + NL + "     * <!-- begin-user-doc -->" + NL + "     * <!-- end-user-doc -->" + NL + "     * @generated" + NL + "     */";
  protected final String TEXT_12 = NL + "     ";
  protected final String TEXT_13 = " ";
  protected final String TEXT_14 = "(";
  protected final String TEXT_15 = ") ";
  protected final String TEXT_16 = "throws ";
  protected final String TEXT_17 = "NotFoundException";
  protected final String TEXT_18 = " {";
  protected final String TEXT_19 = NL + "        // TODO Auto-generated method stub" + NL + "        throw new UnsupportedOperationException(\"";
  protected final String TEXT_20 = " not implemented\");";
  protected final String TEXT_21 = NL + "        ";
  protected final String TEXT_22 = " ao = ";
  protected final String TEXT_23 = "Factory.create";
  protected final String TEXT_24 = "();";
  protected final String TEXT_25 = "        " + NL + "        ao.set";
  protected final String TEXT_26 = "(";
  protected final String TEXT_27 = ");";
  protected final String TEXT_28 = NL + "        ao.execute();";
  protected final String TEXT_29 = NL + "        if (ao.getResult() == null) {" + NL + "            throw new ";
  protected final String TEXT_30 = "NotFoundException(\"No ";
  protected final String TEXT_31 = " found with ";
  protected final String TEXT_32 = ": \" + ";
  protected final String TEXT_33 = ");" + NL + "        }";
  protected final String TEXT_34 = NL + "        return ao.getResult();";
  protected final String TEXT_35 = "       " + NL + "     }" + NL + "     ";
  protected final String TEXT_36 = NL + "  " + NL + "   " + NL + "" + NL + "} ";

  public String generate(Object argument)
  {
    StringBuffer stringBuffer = new StringBuffer();
    

    EClass eClass = (EClass) argument;
EPackage ePackage = eClass.getEPackage();

if (!eClass.getName().endsWith("Repository")) {
    throw new IllegalArgumentException("Expect name of class argument to end with \"Repository\""); 
}
String baseName = eClass.getName().substring(0, eClass.getName().length() - "Repository".length());
String productType = "Access";

EcoreGenerationHelper h = new EcoreGenerationHelper();
String apiPackageName = h.getQualifiedName(ePackage.getESuperPackage()) + ".accessapi";
String fwApiPackageName = h.getQualifiedName(ePackage.getESuperPackage().getESuperPackage()) + ".framework.accessapi";
h.makeImportManager(ePackage);

    stringBuffer.append(TEXT_1);
    stringBuffer.append(TEXT_2);
    stringBuffer.append(h.getQualifiedName(eClass.getEPackage()));
    stringBuffer.append(TEXT_3);
    
StringBuffer importStringBuffer = stringBuffer;
int importInsertionPoint = stringBuffer.length();
h.getImportManager().addCompilationUnitImports(stringBuffer.toString());
h.addImport(apiPackageName + "." + baseName + productType + "Factory");
// by some strange reason the import of in forId does not work
h.addImport("java.util.Map");
h.addImport(fwApiPackageName + ".*");
h.addImport(apiPackageName + ".*");

    stringBuffer.append(TEXT_4);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_5);
    stringBuffer.append(h.getName(eClass));
    stringBuffer.append(TEXT_6);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_7);
    stringBuffer.append(h.uncapName(baseName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_8);
    stringBuffer.append(baseName);
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_9);
    stringBuffer.append(h.getName(eClass));
    stringBuffer.append(TEXT_10);
    for (EOperation op : h.getOperations(eClass)) {
  // a few naming mapping conventions
  String mappedOpName = h.getMappedOperationName(op);
  boolean findById = (mappedOpName.equals("findById"));

    stringBuffer.append(TEXT_11);
    stringBuffer.append(TEXT_12);
    stringBuffer.append(h.getVisibility(op) );
    stringBuffer.append(h.getTypeName(op));
    stringBuffer.append(TEXT_13);
    stringBuffer.append(h.getName(op));
    stringBuffer.append(TEXT_14);
    stringBuffer.append(h.getParameterList(op));
    stringBuffer.append(TEXT_15);
     if (findById) {
    stringBuffer.append(TEXT_16);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_17);
    }
    stringBuffer.append(TEXT_18);
     if (h.getAnnotation(op, "noaccessobject") != null) {
    stringBuffer.append(TEXT_19);
    stringBuffer.append(mappedOpName);
    stringBuffer.append(TEXT_20);
    } else {
    stringBuffer.append(TEXT_21);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(h.getGenericType(op));
    stringBuffer.append(TEXT_22);
    stringBuffer.append(h.uncapName(baseName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_23);
    stringBuffer.append(h.capName(mappedOpName));
    stringBuffer.append(productType);
    stringBuffer.append(TEXT_24);
    for (EParameter parameter : h.getParameters(op)) {
    stringBuffer.append(TEXT_25);
    stringBuffer.append(h.capName(h.getName(parameter)));
    stringBuffer.append(TEXT_26);
    stringBuffer.append(h.getName(parameter));
    stringBuffer.append(TEXT_27);
    }
    stringBuffer.append(TEXT_28);
    if (!h.getTypeName(op).equals("void")) {
    if (findById) {
        EParameter idParam = h.getParameters(op).get(0);
      
    stringBuffer.append(TEXT_29);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_30);
    stringBuffer.append(baseName);
    stringBuffer.append(TEXT_31);
    stringBuffer.append(h.getName(idParam));
    stringBuffer.append(TEXT_32);
    stringBuffer.append(h.getName(idParam));
    stringBuffer.append(TEXT_33);
    }
    stringBuffer.append(TEXT_34);
    }
    }
    stringBuffer.append(TEXT_35);
    }
    stringBuffer.append(TEXT_36);
    importStringBuffer.insert(importInsertionPoint, h.getImportManager().computeSortedImports());
    return stringBuffer.toString();
  }
}
